;;;; uuid-lib-c-api.scm
;;;; Kon Lovett, Mar '07
;;;; BSD

;;; C API Chicken wrapper for Theodore Y. Ts'o OSF DCE 1.1 UUID Suite

(module uuid-lib-c-api

  (;export
    sizeof-uuid
    length-uuid-string
    uuid_is_null
    uuid_compare
    uuid_clear
    uuid_copy
    uuid_generate
    uuid_generate_random
    uuid_generate_time
    uuid_parse
    uuid_unparse
    uuid_unparse_upper
    uuid_unparse_lower)

  (import scheme chicken foreign)

;;;

#>
#include <uuid/uuid.h>
<#

(define sizeof-uuid (foreign-value "sizeof(uuid_t)" int))

(define length-uuid-string 36)

(define uuid_is_null
  (foreign-lambda int uuid_is_null c-pointer))

(define uuid_compare
  (foreign-lambda int uuid_compare c-pointer c-pointer))

(define uuid_clear
  (foreign-lambda void uuid_clear c-pointer))

(define uuid_copy
  (foreign-lambda void uuid_copy c-pointer c-pointer))

(define uuid_generate
  (foreign-lambda void uuid_generate c-pointer))

(define uuid_generate_random
  (foreign-lambda void uuid_generate_random c-pointer))

(define uuid_generate_time
  (foreign-lambda void uuid_generate_time c-pointer))

(define uuid_parse
  (foreign-lambda int uuid_parse c-string c-pointer))

(define uuid_unparse
  (foreign-lambda void uuid_unparse c-pointer c-pointer))

(define uuid_unparse_upper
  (foreign-lambda void uuid_unparse_upper c-pointer c-pointer))

(define uuid_unparse_lower
  (foreign-lambda void uuid_unparse_lower c-pointer c-pointer))

) ;module uuid-lib-c-api
